lorom
org $818131
Setup:
	REP #$30
	STZ $00
	STZ $18
	LDA #$7ECD
	STA $04
	LDA #$CD52
	STA $03
	TDC
	RTS
GetCurrentPointer:
	PHX
	LDX $18
	CPX #$0012	;00 for 0 maps, 03 for 1 map, 06 for 2, 09 for 3, 0C for 4, 0F for 5, 12 for 6 (Normal), 15 for 7 (+Ceres), 18 for 8 (+Debug)
	LDA $82964A,X	;If you've changed the pointers around edit this. You'll know if you did.
	STA $00
	LDA $82964B,X
	STA $01
	INX
	INX
	INX
	STX $18
	PLX
	LDY #$0FFE
	RTS

;$82E4: Load Map
org $8182E4
	PHP
	JSR Setup
	LDX #$0702
-
	STA $7ECD50,X
	DEX
	DEX
	BNE -
---
	JSR GetCurrentPointer
	BCS ++
--
	LDA #$0080
	STA $16
-
	LDA [$00],Y
	AND #$E3FF	;Ignore palette. Stupid Crateria.
	CMP #$001F
	BNE +
	DEY
	DEY
	BMI ---
	ROR $16
	BCS -
	BRA --
+
	PHY
	TYA
	LSR
	LSR
	LSR
	LSR
	TAY
	SEP #$20
	LDA $7ED91C,X
	STA [$03],Y
	INX
	REP #$21
	PLA
	AND #$FFF0
	DEC
	DEC
	TAY
	BRA --
++
	PLP
	RTS
	


;$834B: Save Map
org $81834B
	PHP
	JSR Setup
	TAX
---
	JSR GetCurrentPointer
	BCS ++
--
	LDA #$0080
	STA $16
-
	LDA [$00],Y
	AND #$E3FF	;Ignore palette. Stupid Crateria.
	CMP #$001F
	BNE +
	DEY
	DEY
	BMI ---
	ROR $16
	BCS -
	BRA --
+
	PHY
	TYA
	LSR
	LSR
	LSR
	LSR
	TAY
	SEP #$20
	LDA [$03],Y
	STA $7ED91C,X
	INX
	REP #$21
	PLA
	AND #$FFF0
	DEC
	DEC
	TAY
	BRA --
++
	PLP
	RTS
